import cv2
import cv2.typing
import typing


# Classes
class HDF5:
    # Functions
    def close(self) -> None: ...

    def grcreate(self, grlabel: str) -> None: ...

    def hlexists(self, label: str) -> bool: ...

    def atexists(self, atlabel: str) -> bool: ...

    def atdelete(self, atlabel: str) -> None: ...

    @typing.overload
    def atwrite(self, value: int, atlabel: str) -> None: ...
    @typing.overload
    def atwrite(self, value: float, atlabel: str) -> None: ...
    @typing.overload
    def atwrite(self, value: str, atlabel: str) -> None: ...
    @typing.overload
    def atwrite(self, value: cv2.typing.MatLike, atlabel: str) -> None: ...
    @typing.overload
    def atwrite(self, value: cv2.UMat, atlabel: str) -> None: ...

    @typing.overload
    def atread(self, value: int, atlabel: str) -> None: ...
    @typing.overload
    def atread(self, value: float, atlabel: str) -> None: ...
    @typing.overload
    def atread(self, value: str, atlabel: str) -> None: ...
    @typing.overload
    def atread(self, atlabel: str, value: cv2.typing.MatLike | None = ...) -> cv2.typing.MatLike: ...
    @typing.overload
    def atread(self, atlabel: str, value: cv2.UMat | None = ...) -> cv2.UMat: ...

    @typing.overload
    def dscreate(self, rows: int, cols: int, type: int, dslabel: str) -> None: ...
    @typing.overload
    def dscreate(self, rows: int, cols: int, type: int, dslabel: str, compresslevel: int) -> None: ...
    @typing.overload
    def dscreate(self, rows: int, cols: int, type: int, dslabel: str, compresslevel: int, dims_chunks: typing.Sequence[int]) -> None: ...
    @typing.overload
    def dscreate(self, rows: int, cols: int, type: int, dslabel: str, compresslevel: int, dims_chunks: int) -> None: ...
    @typing.overload
    def dscreate(self, n_dims: int, sizes: int, type: int, dslabel: str) -> None: ...
    @typing.overload
    def dscreate(self, n_dims: int, sizes: int, type: int, dslabel: str, compresslevel: int) -> None: ...
    @typing.overload
    def dscreate(self, sizes: typing.Sequence[int], type: int, dslabel: str, compresslevel: int = ..., dims_chunks: typing.Sequence[int] = ...) -> None: ...
    @typing.overload
    def dscreate(self, n_dims: int, sizes: int, type: int, dslabel: str, compresslevel: int, dims_chunks: int) -> None: ...

    def dsgetsize(self, dslabel: str, dims_flag: int = ...) -> typing.Sequence[int]: ...

    def dsgettype(self, dslabel: str) -> int: ...

    @typing.overload
    def dswrite(self, Array: cv2.typing.MatLike, dslabel: str) -> None: ...
    @typing.overload
    def dswrite(self, Array: cv2.UMat, dslabel: str) -> None: ...
    @typing.overload
    def dswrite(self, Array: cv2.typing.MatLike, dslabel: str, dims_offset: int) -> None: ...
    @typing.overload
    def dswrite(self, Array: cv2.UMat, dslabel: str, dims_offset: int) -> None: ...
    @typing.overload
    def dswrite(self, Array: cv2.typing.MatLike, dslabel: str, dims_offset: typing.Sequence[int], dims_counts: typing.Sequence[int] = ...) -> None: ...
    @typing.overload
    def dswrite(self, Array: cv2.UMat, dslabel: str, dims_offset: typing.Sequence[int], dims_counts: typing.Sequence[int] = ...) -> None: ...
    @typing.overload
    def dswrite(self, Array: cv2.typing.MatLike, dslabel: str, dims_offset: int, dims_counts: int) -> None: ...
    @typing.overload
    def dswrite(self, Array: cv2.UMat, dslabel: str, dims_offset: int, dims_counts: int) -> None: ...

    @typing.overload
    def dsinsert(self, Array: cv2.typing.MatLike, dslabel: str) -> None: ...
    @typing.overload
    def dsinsert(self, Array: cv2.UMat, dslabel: str) -> None: ...
    @typing.overload
    def dsinsert(self, Array: cv2.typing.MatLike, dslabel: str, dims_offset: int) -> None: ...
    @typing.overload
    def dsinsert(self, Array: cv2.UMat, dslabel: str, dims_offset: int) -> None: ...
    @typing.overload
    def dsinsert(self, Array: cv2.typing.MatLike, dslabel: str, dims_offset: typing.Sequence[int], dims_counts: typing.Sequence[int] = ...) -> None: ...
    @typing.overload
    def dsinsert(self, Array: cv2.UMat, dslabel: str, dims_offset: typing.Sequence[int], dims_counts: typing.Sequence[int] = ...) -> None: ...
    @typing.overload
    def dsinsert(self, Array: cv2.typing.MatLike, dslabel: str, dims_offset: int, dims_counts: int) -> None: ...
    @typing.overload
    def dsinsert(self, Array: cv2.UMat, dslabel: str, dims_offset: int, dims_counts: int) -> None: ...

    @typing.overload
    def dsread(self, dslabel: str, Array: cv2.typing.MatLike | None = ...) -> cv2.typing.MatLike: ...
    @typing.overload
    def dsread(self, dslabel: str, Array: cv2.UMat | None = ...) -> cv2.UMat: ...
    @typing.overload
    def dsread(self, dslabel: str, dims_offset: int, Array: cv2.typing.MatLike | None = ...) -> cv2.typing.MatLike: ...
    @typing.overload
    def dsread(self, dslabel: str, dims_offset: int, Array: cv2.UMat | None = ...) -> cv2.UMat: ...
    @typing.overload
    def dsread(self, dslabel: str, dims_offset: typing.Sequence[int], Array: cv2.typing.MatLike | None = ..., dims_counts: typing.Sequence[int] = ...) -> cv2.typing.MatLike: ...
    @typing.overload
    def dsread(self, dslabel: str, dims_offset: typing.Sequence[int], Array: cv2.UMat | None = ..., dims_counts: typing.Sequence[int] = ...) -> cv2.UMat: ...
    @typing.overload
    def dsread(self, dslabel: str, dims_offset: int, dims_counts: int, Array: cv2.typing.MatLike | None = ...) -> cv2.typing.MatLike: ...
    @typing.overload
    def dsread(self, dslabel: str, dims_offset: int, dims_counts: int, Array: cv2.UMat | None = ...) -> cv2.UMat: ...

    def kpgetsize(self, kplabel: str, dims_flag: int = ...) -> int: ...



# Functions
def open(HDF5Filename: str) -> HDF5: ...


